# load vocabulary:
library(network)

# Set working directory:
setwd("<put appropriate path here>")

# load data sets:
load("testmatrices.RData")

# take a look:
mat1
mat2
mat3

# pool the labels into one vector (and arrange them alphabetically):
IDlabels <- rownames(table(c(rownames(mat1),rownames(mat2),rownames(mat3))))

# Make new matrices, with appropriate size & 10s for structural
# missings, first fill matrices with good entries where possible:
newmat1 <- mat1[match(IDlabels,rownames(mat1)), match(IDlabels,rownames(mat1))]
newmat2 <- mat2[match(IDlabels,rownames(mat2)), match(IDlabels,rownames(mat2))]
newmat3 <- mat3[match(IDlabels,rownames(mat3)), match(IDlabels,rownames(mat3))]

# now put structural missing code into the columns and rows where it belongs:
newmat1[,is.na(colnames(newmat1))] <- 10; newmat1[is.na(rownames(newmat1)),] <- 10
newmat2[,is.na(colnames(newmat2))] <- 10; newmat2[is.na(rownames(newmat2)),] <- 10
newmat3[,is.na(colnames(newmat3))] <- 10; newmat3[is.na(rownames(newmat3)),] <- 10

# finally replace labels of structurally missing actors by proper ones:
rownames(newmat1) <- IDlabels; colnames(newmat1) <- IDlabels
rownames(newmat2) <- IDlabels; colnames(newmat2) <- IDlabels
rownames(newmat3) <- IDlabels; colnames(newmat3) <- IDlabels

# take a look:
newmat1
newmat2
newmat3
